//+------------------------------------------------------------------+
//|                                               TSR_Historical.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
#property link      " Thanks to IgorAD for his AllPivots_v1 which I based this indicator on" 
#property link      " Adapted by cja"

#property indicator_chart_window
extern string IIIIIIIIIIIIIIIIIIIIIIIIIIIIIII="<<<< Historical Settings >>>>>>>>>>>>>>>>>>>";
extern int  CountDays=10;
extern string IIIIIIIIIIIIIIIIIIIIIIIIIIIII="<<<< Rectangle or Lines >>>>>>>>>>>>>>>>>>>>";
extern bool Show_Graphics = true;
extern string IIIIIIIIIIIIIIIIIIIIIIIIIIII="<<<< Label Settings >>>>>>>>>>>>>>>>>>>>";
extern bool Show_Labels = true; 
extern int fontsize=10;
extern int Move_font = 0;
extern string IIIIIIIIIIIIIIIIIIIIIII="<<<< Pivot Settings >>>>>>>>>>>>>>>>>>>>";
extern bool Show_Pivot = false;
extern color Pivot_color = Silver; 
extern int Pivot_LineStyle = 3;
extern int Pivot_Width = 1;
extern string IIIIIIIIIIIIIIIIIIIIII="<<<< Open Settings >>>>>>>>>>>>>>>>>>>>";
extern bool Show_Open = true; 
extern color Open_color = Coral;
extern int Open_LineStyle = 0;
extern int Open_Width = 2;
extern string IIIIIIIIIIIIIIIIIIIIIIIIII="<<<< Daily Av Settings >>>>>>>>>>>>>>>>>>>>";
extern color DAV50P_color = Lime;
extern int DAV50_LineStyle = 0;
extern int DAV50_LineWidth = 3;
extern color DAV50M_color = Aqua;
extern color DAV_top_Low_Label = Coral; 
extern color DAV_color = Green;
extern int DAV_LineStyle = 4;
extern int DAV_LineWidth = 0;
extern string IIIIIIIIIIIIIIIIIIIIIIIIIII="<<<< Hi/Low Settings >>>>>>>>>>>>>>>>>>>>";
extern color DailyHigh_color = Red;
extern int Daily_HILOW_LineStyle = 4;
extern color DailyLow_color = Red;
extern string IIIIIIIIIIIIIIIIIIIIIIIII="<<<< Adjustable Av Entry >>>>>>>>>>>>>";
extern bool Show_Factor_Levels = false;
extern int Factor = 6;
extern int Factor_LineStyle = 2;
extern int Factor_LineWidth = 1;
extern color Factor_color_UP = DodgerBlue;
extern color Factor_color_DN = Violet;
extern int Move_Factor_Text = 10; 

  
   datetime time1;
   datetime time2;
   double open,close,high,low,value1,value2,value3,value4,value5,value6,value7,value8;
   double P,AV50P,AV50M,HI,LO,phigh,plow,AVFUP,AVFDN;
  
   int shift, num;
     
   void ObjDel()
   {
      for (;num<=CountDays;num++)
      {
      ObjectDelete("PP["+num+"]");
      ObjectDelete("Open["+num+"]");
      ObjectDelete("50% Daily Av["+num+"]");
      ObjectDelete("50% Daily Av.["+num+"]");
      ObjectDelete("100% Daily Av["+num+"]");
      ObjectDelete("100% Daily Av.["+num+"]");
      ObjectDelete("Daily High["+num+"]");
      ObjectDelete("Daily Low["+num+"]");
      ObjectDelete("Factor Up["+num+"]");
      ObjectDelete("Factor Down["+num+"]");
      ObjectDelete("HILO["+num+"]");
      ObjectDelete("DAV50["+num+"]");
      ObjectDelete("DAV["+num+"]");
      ObjectDelete("DFACTOR["+num+"]");
           
      }
   }
     void PlotLine(string name,double value,double line_color,double style,double width)
   {
   ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, false);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_COLOR, line_color);
   }
   void  Rec(string rec,double value1,double value2,double line_color)
   {
   ObjectCreate(rec,OBJ_RECTANGLE,0,time1,value1,time2,value2);
   ObjectSet(rec, OBJPROP_PRICE1,value1);
   ObjectSet(rec, OBJPROP_PRICE2,value2);
   ObjectSet(rec, OBJPROP_RAY, false);
   ObjectSet(rec, OBJPROP_BACK, true);
   ObjectSet(rec, OBJPROP_COLOR, line_color);
   }
   
 int init()
  {

  return(0);
  }
   
   
int deinit()
  {
  ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(0,OBJ_LABEL);
    ObjectsDeleteAll(0,OBJ_RECTANGLE);
   ObjDel();
   Comment("");
   return(0);
  }

int start()
  {
  int i=0;
     
  ObjDel();
  num=0;
  
  for (shift=CountDays-1;shift>=0;shift--)
  {
  time1=iTime(NULL,PERIOD_D1,shift);
  i=shift-1;
  if (i<0) 
  time2=Time[0];
  else
  time2=iTime(NULL,PERIOD_D1,i)-Period()*60;
  
    double HI3 = iHigh(NULL,1440,shift);
    double LOW3 = iLow(NULL,1440,shift);
    double HI4 = iHigh(NULL,1440,1);
    double LOW4 = iLow(NULL,1440,1);
    double HI5 = iHigh(NULL,1440,2);
    double LOW5 = iLow(NULL,1440,2);
    double HI6 = iHigh(NULL,1440,3);
    double LOW6 = iLow(NULL,1440,3);
    double HI7 = iHigh(NULL,1440,4);
    double LOW7 = iLow(NULL,1440,4);
    double HI8 = iHigh(NULL,1440,5);
    double LOW8 = iLow(NULL,1440,5);
    double HI9 = iHigh(NULL,1440,6);
    double LOW9 = iLow(NULL,1440,6);
    double HI10 = iHigh(NULL,1440,7);
    double LOW10 = iLow(NULL,1440,7);
    double HI11 = iHigh(NULL,1440,8);
    double LOW11 = iLow(NULL,1440,8);
    double HI12 = iHigh(NULL,1440,9);
    double LOW12 = iLow(NULL,1440,9);
    double HI13 = iHigh(NULL,1440,10);
    double LOW13 = iLow(NULL,1440,10);
    double HI14 = iHigh(NULL,1440,11);
    double LOW14 = iLow(NULL,1440,11);
    double HI15 = iHigh(NULL,1440,12);
    double LOW15 = iLow(NULL,1440,12);
    double HI16 = iHigh(NULL,1440,13);
    double LOW16 = iLow(NULL,1440,13);
    double HI17 = iHigh(NULL,1440,14);
    double LOW17 = iLow(NULL,1440,14);
    double HI18 = iHigh(NULL,1440,15);
    double LOW18 = iLow(NULL,1440,15);
    double HI19 = iHigh(NULL,1440,16);
    double LOW19 = iLow(NULL,1440,16);
    double HI20 = iHigh(NULL,1440,17);
    double LOW20 = iLow(NULL,1440,17);
    double HI21 = iHigh(NULL,1440,18);
    double LOW21 = iLow(NULL,1440,18);
    double HI22 = iHigh(NULL,1440,19);
    double LOW22 = iLow(NULL,1440,19);
    double HI23 = iHigh(NULL,1440,20);
    double LOW23 = iLow(NULL,1440,20);
    
    double ONE = (HI4-LOW4);
  
    double FIVE = ((HI4-LOW4)+(HI5-LOW5)+(HI6-LOW6)+(HI7-LOW7)+(HI8-LOW8))/5;
           
    double TEN = ((HI4-LOW4)+(HI5-LOW5)+(HI6-LOW6)+(HI7-LOW7)+(HI8-LOW8)+
                  (HI9-LOW9)+(HI10-LOW10)+(HI11-LOW11)+(HI12-LOW12)+(HI13-LOW13))/10;
                    
    double TWENTY = ((HI4-LOW4)+(HI5-LOW5)+(HI6-LOW6)+(HI7-LOW7)+(HI8-LOW8)+
               (HI9-LOW9)+(HI10-LOW10)+(HI11-LOW11)+(HI12-LOW12)+(HI13-LOW13)+
               (HI14-LOW14)+(HI15-LOW15)+(HI16-LOW16)+(HI17-LOW17)+(HI18-LOW18)+
               (HI19-LOW19)+(HI20-LOW20)+(HI21-LOW21)+(HI22-LOW22)+(HI23-LOW23))/20; 
                                              
    double AV = (ONE+FIVE+TEN+TWENTY)/4;// New Setting AV = (FIVE+TEN+TWENTY)/3;
     double AV1 = (ONE+FIVE+TEN+TWENTY)/Factor;
    
     
  high  = iHigh(NULL,PERIOD_D1,shift);
  low   = iLow(NULL,PERIOD_D1,shift);
  open  = iOpen(NULL,PERIOD_D1,shift);
  close = iClose(NULL,PERIOD_D1,shift+1);
  phigh  = iHigh(NULL,PERIOD_D1,shift+1);
  plow   = iLow(NULL,PERIOD_D1,shift+1);
  
  
   P=(phigh+plow+close)/3;
   AV50P = low + 0.50*AV;
   AV50M = high - 0.50*AV;
   if (Show_Factor_Levels == true)
   {
   AVFUP = low + 0.50*AV1;
   AVFDN = high - 0.50*AV1;
   }
   HI = HI3;
   LO = LOW3;
   value1=HI3;
   value2=LOW3;
   value3=low + 0.50*AV;
   value4=high - 0.50*AV;
   value5=low + AV;
   value6=high - AV;
   value7 = low + 0.50*AV1;
   value8 = high - 0.50*AV1;
    
  low=Open[i]; high=Open[i];
      
  time2=time1+PERIOD_D1*60;
  
  num=shift;
  
    if(Show_Graphics==true)
    {
    Rec("HILO["+num+"]",value1,value2,DarkGreen);
    Rec("DAV50["+num+"]",value3,value4,Maroon);
    Rec("DAV["+num+"]",value5,value6,C'0,44,09');
    if (Show_Factor_Levels == true)
   {
    Rec("FACTOR["+num+"]",value7,value8,C'40,20,00');
    }}
  
  if(Show_Pivot==true)
   {     
  PlotLine("PP["+num+"]",P,Pivot_color,Pivot_LineStyle,Pivot_Width);
  }
  if(Show_Open==true)
   { 
  PlotLine("Open["+num+"]",open,Open_color,Open_LineStyle,Open_Width);
  }
       
   PlotLine("50% Daily Av["+num+"]",AV50P,DAV50P_color,DAV50_LineStyle,DAV50_LineWidth  );
  
   PlotLine("Daily High["+num+"]",HI3,DailyHigh_color,Daily_HILOW_LineStyle,1 );
               
   PlotLine("50% Daily Av.["+num+"]",AV50M,DAV50M_color,DAV50_LineStyle,DAV50_LineWidth  );
  
   PlotLine("Daily Low["+num+"]",LOW3,DailyLow_color,Daily_HILOW_LineStyle,1 );
   
   PlotLine("Top Daily Av.["+num+"]",value6,DAV_color,DAV_LineStyle,DAV_LineWidth  );
    
   PlotLine("Low Daily Av.["+num+"]",value5,DAV_color,DAV_LineStyle,DAV_LineWidth  );
   
   if (Show_Factor_Levels == true)
   {
   PlotLine("Factor Up["+num+"]",AVFUP,Factor_color_UP ,Factor_LineStyle,Factor_LineWidth);
   
   PlotLine("Factor Down["+num+"]",AVFDN,Factor_color_DN ,Factor_LineStyle,Factor_LineWidth);
   }
  
  }
  if(Show_Labels==true)
  { 
   if(Show_Pivot==true)
   { 
  if(ObjectFind("TSRP") != 0){
  ObjectCreate("TSRP", OBJ_TEXT, 0, Time[Move_font], P);
  ObjectSetText("TSRP", "                      Pivot ", fontsize, "Arial",Pivot_color );
  }else{  ObjectMove("TSRP", 0, Time[Move_font], P);}
  }
   if(Show_Open==true)
   { 
  if(ObjectFind("TSRO") != 0){
  ObjectCreate("TSRO", OBJ_TEXT, 0, Time[Move_font], open);
  ObjectSetText("TSRO", "                       Open ", fontsize, "Arial",Open_color );
  }else{  ObjectMove("TSRO", 0, Time[Move_font], open);}
  }
  
  if(ObjectFind("TSR1") != 0){
  ObjectCreate("TSR1", OBJ_TEXT, 0, Time[Move_font], AV50P);
  ObjectSetText("TSR1", "                                            Dynamic 50% DAV Hi ", fontsize, "Arial",DAV50P_color);
  }else{  ObjectMove("TSR1", 0, Time[Move_font], AV50P);}
  
  if(ObjectFind("TSR2") != 0){
  ObjectCreate("TSR2", OBJ_TEXT, 0, Time[Move_font], AV50M);
  ObjectSetText("TSR2", "                                            Dynamic 50% DAV Low  ", fontsize, "Arial",DAV50M_color );
  }else{  ObjectMove("TSR2", 0, Time[Move_font], AV50M);}
 
   if(ObjectFind("TSR") != 0){
  ObjectCreate("TSR", OBJ_TEXT, 0, Time[Move_font],HI3);
  ObjectSetText("TSR", "                              Daily High ", fontsize, "Arial",DailyHigh_color );
  }else{  ObjectMove("TSR", 0, Time[Move_font], HI3);}
  
  if(ObjectFind("TSR4") != 0){
  ObjectCreate("TSR4", OBJ_TEXT, 0, Time[Move_font], LOW3);
  ObjectSetText("TSR4", "                              Daily Low ", fontsize, "Arial",DailyLow_color );
  }else{  ObjectMove("TSR4", 0, Time[Move_font], LOW3);}
  if (Show_Factor_Levels == true)
   {
    if(ObjectFind("TSR5") != 0){
  ObjectCreate("TSR5", OBJ_TEXT, 0, Time[Move_Factor_Text],AVFUP);
  ObjectSetText("TSR5", "                              F ["+Factor+"] LONG", fontsize, "Arial",Factor_color_UP  );
  }else{  ObjectMove("TSR5", 0, Time[Move_Factor_Text], AVFUP);}
  
  if(ObjectFind("TSR6") != 0){
  ObjectCreate("TSR6", OBJ_TEXT, 0, Time[Move_Factor_Text], AVFDN);
  ObjectSetText("TSR6", "                              F ["+Factor+"] SHORT", fontsize, "Arial",Factor_color_DN  );
  }else{  ObjectMove("TSR6", 0, Time[Move_Factor_Text], AVFDN);}
  }
  if(ObjectFind("TSR7") != 0){
  ObjectCreate("TSR7", OBJ_TEXT, 0, Time[Move_font], value5);
  ObjectSetText("TSR7", "                      Top Daily Range ", fontsize, "Arial",DAV_top_Low_Label);
  }else{  ObjectMove("TSR7", 0, Time[Move_font], value5);}
  
  if(ObjectFind("TSR8") != 0){
  ObjectCreate("TSR8", OBJ_TEXT, 0, Time[Move_font], value6);
  ObjectSetText("TSR8", "                      Low Daily Range ", fontsize, "Arial",DAV_top_Low_Label);
  }else{  ObjectMove("TSR8", 0, Time[Move_font], value6);}
  }
  
       
    return(0);
  }
//+------------------------------------------------------------------+


